CREATE DATABASE IF NOT EXISTS piazzadb;

USE piazzadb;

DROP TABLE IF EXISTS responses;
DROP TABLE IF EXISTS questions;
DROP TABLE IF EXISTS enrollments;
DROP TABLE IF EXISTS courses;
DROP TABLE IF EXISTS users;


CREATE TABLE users(
  id INT PRIMARY KEY AUTO_INCREMENT,
  username VARCHAR(255) NOT NULL,
  password VARCHAR(255) NOT NULL,
  sessionid VARCHAR(63)
);

INSERT INTO users(username, password)
VALUES ("dubs", "boundless"),
       ("mowgli", "debugdog"),
       ("tal", "piazza party"),
       ("austin", "hopper"),
       ("sven", "pyukumukumimikyu"),
       ("melissa", "xkcd1975");

CREATE TABLE courses(
  id INT PRIMARY KEY AUTO_INCREMENT,
  name VARCHAR(255) NOT NULL
);

INSERT INTO courses(name)
VALUES ("CSE 154"),
       ("CSE 331"),
       ("MATH 126"),
       ("BIOL 180"),
       ("CSE 484");

CREATE TABLE enrollments(
  course INT NOT NULL,
  user INT NOT NULL,
  FOREIGN KEY(course) REFERENCES courses(id),
  FOREIGN KEY(user) REFERENCES users(id)
);

INSERT INTO enrollments(course, user)
VALUES (1, 1),
       (3, 1),
       (1, 2),
       (4, 2),
       (4, 3),
       (3, 4),
       (4, 4),
       (2, 5),
       (5, 5),
       (5, 6);

CREATE TABLE questions(
  id INT PRIMARY KEY AUTO_INCREMENT,
  question TEXT NOT NULL,
  asker INT NOT NULL,
  course INT NOT NULL,
  FOREIGN KEY(asker) REFERENCES users(id),
  FOREIGN KEY(course) REFERENCES courses(id)
);

INSERT INTO questions(question, asker, course)
VALUES ("Does anyone know what e^(i*pi) is?", 1, 3),
       ("How did Tal get her WPM so high?", 1, 1),
       ("Can I use JOIN on JSON?", 1, 1),
       ("How much colder is a polar coordinate?", 1, 3),
       ("What are the most integral skills I can derrive from this course?", 1, 3),
       ("What species do I belong to?", 2, 4),
       ("How much wood could a wood chuck chuck if a wood chuck could chuck wood?", 2, 4),
       ("Can I get a dog themed analogy for asynchronous functions?", 2, 1),
       ("How can mirrors be real if our eyes aren't real?", 3, 4),
       ("Sorry, ignore that last question.", 3, 4),
       ("Can I manage this Piazza board? I think I would do a better job ;).", 3, 4),
       ("Can we replace WebAssign with GitGrade?", 4, 3),
       ("I just deleted System 32, but it didn't work. Am I doing things right?", 5, 2),
       ("Another student just hacked me, what is the best approach to hack them back?", 5, 5),
       ("Can I do a SQL injection attack on the course website? Pretty please?", 5, 5),
       ("Can I just do this in HTML and Javascript? It would be a lot easier.", 5, 2),
       ("My dog hacked my homework, I swear!", 6, 5),
       ("Sorry for the unrelated question, but can a match stick?", 6, 5);

CREATE TABLE responses(
  id INT PRIMARY KEY AUTO_INCREMENT,
  question INT NOT NULL,
  response TEXT NOT NULL,
  responder INT NOT NULL,
  FOREIGN KEY(question) REFERENCES questions(id),
  FOREIGN KEY(responder) REFERENCES users(id)
);

INSERT INTO responses(question, response, responder)
VALUES (1, "I'm going to have to give this question a -1", 2),
       (1, "Please, only post positive question on this board.", 6),
       (2, "100 push-ups, 100 sit-ups, 100 squats, and 10KM running, every single day!!!", 3),
       (2, "She manually added it to the JSON. Don't tell her I said that though :x.", 5),
       (3, "Nope", 2),
       (5, "The ability to differentiate between things.", 4),
       (6, "Dog", 1),
       (7, "As much wood as a wood chuck would chuck if a wood chuck could chuck and should chuck wood", 3),
       (9, "How can our eyes be real if they are inside the mirrors?", 5),
       (11, "Yes, on the condition that you do not respond with Jayden Smith quotes.", 6),
       (12, "I second this motion.", 5),
       (13, "Have you tried randomizing random registry values? I hear it can help restore System 32.", 4),
       (14, "Build a fake copy of the course website and serve them slightly incorrect assignment specifications >:)", 3),
       (16, "JavaScript is basically just Java but it's a Script, I'm sure it's fine.", 1),
       (17, "Likely story...", 4),
       (17, "Sorry! My dog stole my computer and typed that, It's not true.", 6),
       (17, "Oh, that makes sense. Sorry for doubting you!", 4),
       (18, "No, but a tin can.", 3)
